﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Net;
using System.ServiceModel.Description;

using System.ServiceModel;
using Microsoft.Xrm.Sdk;
using Microsoft.Xrm.Sdk.Messages;
using Microsoft.Xrm.Sdk.Client;
using Microsoft.Xrm.Sdk.Query;
using Microsoft.Crm.Sdk.Messages;
using Microsoft.Xrm.Tooling.Connector;
using Microsoft.Xrm.Sdk.Metadata;

namespace DYN365___Auto_Number
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnCreate_Click(object sender, EventArgs e)
        {

            try
            {
                IOrganizationService oServiceProxy = null;

                txtOutput.Text = "";
                sb_LogStatus("Logging into Dynamics 365");

                //Log in:
                CrmServiceClient oDYN365Service = new Microsoft.Xrm.Tooling.Connector.CrmServiceClient("AuthType=Office365;Username=" + txtUsername.Text + ";Password=" + txtPassword.Text + ";URL=" + txtURL.Text + ";");

                oServiceProxy = (IOrganizationService)oDYN365Service.OrganizationWebProxyClient != null ? (IOrganizationService)oDYN365Service.OrganizationWebProxyClient : (IOrganizationService)oDYN365Service.OrganizationServiceProxy;

                sb_LogStatus("Creating new auto number for: " + txtEntity.Text + " and field: " + txtLogicalName.Text);

                CreateAttributeRequest oSerialNumberAttributeRequest = new CreateAttributeRequest
                {
                    EntityName = txtEntity.Text,
                    Attribute = new StringAttributeMetadata
                    {
                        //Define the format of the attribute
                        AutoNumberFormat = txtAutoNFormat.Text,
                        LogicalName = txtLogicalName.Text,
                        SchemaName = txtSchemaName.Text,

                        RequiredLevel = new AttributeRequiredLevelManagedProperty(AttributeRequiredLevel.None),

                        MaxLength = Convert.ToInt16(txtLength.Text.ToString()), // The MaxLength defined for the string attribute must be greater than the length of the AutoNumberFormat value, that is, it should be able to fit in the generated value.
                        DisplayName = new Microsoft.Xrm.Sdk.Label(txtDisplayName.Text, 1033),
                        Description = new Microsoft.Xrm.Sdk.Label(txtDescription.Text, 1033)
                    }
                };

                oServiceProxy.Execute(oSerialNumberAttributeRequest);

                //Check if the start seed needs to be updated:
                if (txtStartValue.TextLength > 0)
                {
                    sb_LogStatus("Updating start value to " + txtStartValue.Text);
                    SetAutoNumberSeedRequest req = new SetAutoNumberSeedRequest();
                    req.EntityName = txtEntity.Text;
                    req.AttributeName = txtLogicalName.Text;
                    req.Value = Convert.ToInt16(txtStartValue.Text);
                    oServiceProxy.Execute(req);
                }

                sb_LogStatus("Process completed successfully!");
            }
            catch (Exception ex)
            {
                sb_LogStatus("ERROR: " + ex.ToString());
            }
        }

        private void sb_LogStatus(string sMessage)
        {
            txtOutput.Text += "\r\n" + sMessage;

            //Force a refresh on the form:
            Application.DoEvents();
        }
    }
}
